/* ============================================================
 * File  : toolbar_bt.cpp
 * Author: Stephane Gibault
 * Date  : Sun Feb 4 2007
 * Description :
 *
 * 
 *  (C) 2007 by Stephane Gibault
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */
#include <QtGui>
#include "toolbar_bt.h"

toolbar_bt::toolbar_bt ( QWidget * parent )
    : QPushButton(parent)
{
	this->setAttribute(Qt::WA_DeleteOnClose);
	isover = 0;
	largeur = 0;
	hauteur = 0;
}

void toolbar_bt::enterEvent ( QEvent * ) 
{
	isover = 1;
}

void toolbar_bt::leaveEvent ( QEvent * ) 
{
	isover = 0;
}

// ********************************
// *** DESSIN DU FOND DU WIDGET ***
// ********************************

void toolbar_bt::paintEvent(QPaintEvent *)
{
	if ( largeur == 0 )
	{
		QPixmap wl_pix_001(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + ".png");
		largeur = wl_pix_001.width();
		hauteur = wl_pix_001.height();
	}

	QPainter p;
	p.begin(this);
	if ( this->isEnabled() == true )
	{
		if ( this->isChecked() == true )
		{
			p.drawPixmap((this->width()-largeur)/2,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "2.png"));
		}
		else
		{
			if ( isover == 1 )
			{
				p.drawPixmap((this->width()-largeur)/2,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "1.png"));
			}
			else
			{
				p.drawPixmap((this->width()-largeur)/2,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + ".png"));
			}
		}
	}
	else
	{
		p.drawPixmap((this->width()-largeur)/2,0,QPixmap(":/Interface/Interface/" + this->text().mid(2,this->text().length()-2) + "3.png"));
	}
	if ( this->statusTip() != "" )
	{
		QFont myfont;
		myfont.setFamily("DejaVu Sans Condensed");
		myfont.setPixelSize ( 10 );
		if ( isover == 1 )
		{
			p.setPen(QColor(255,255,255));
		}
		else
		{
			p.setPen(QColor(240,240,240));
		}
		p.setFont(myfont);

		p.drawText(QRect(0,hauteur,this->width(),this->height()-hauteur), Qt::AlignCenter, this->statusTip());
	}
	p.end();
}

